DevOps API

  • 릴리스 버전: Australia
  • 업데이트 날짜 2026년 03월 12일
  • 소요 시간: 271분
  • The DevOps API provides endpoints that enable the interaction with external DevOps tools.

    This REST API enables integrators to:

    • Retrieve the available DevOps tools associated with an instance.
    • Retrieve the schema object for a code resource, plan, or orchestration resource.
    • Check if an orchestration task is under change control and check its change control status.
    • Create callbacks to associate with task executions under change control.
    • Send various event payloads, which are transformed into normalized objects and stored as code, orchestration, and plan objects.
    • Search a commit, branch, or repository using encoded queries and specific search/sort criteria.
    • Register artifact versions and packages along with their associated pipeline execution and commits.
    • Create and manage onboarding application and tool events.

    For additional information, see DevOps Config.

    Starting with v2, this API supports token-based authentication. Tokens can be acquired by clicking the Copy token button on the tool record, located in the Tool [sn_devops_tool] table. The token can then be used in an authorization header in the format Authorization: sn_devops.DevOpsToken <tool_sys_id>:<tool_token>.
    주:
    If Basic Auth details (user name and password) are provided in addition to an authorization header with token, Basic Auth takes precedence.

    If the devops.system user is not available in your instance, use the Switch to this user after token based authentication is successful property. This property enables setting any user that has the sn_devops.integration role, which is needed to complete the token authentication. For information, see DevOps Change Velocity properties.

    DevOps - GET /devops/code/schema

    Returns the schema object for a specified code resource: commit, repository, or branch.

    Once you have the required schema object, use it to create the request body for your corresponding POST call; POST /code/commit, POST /code/repository, or POST /code/branch.

    주:
    This endpoint only returns the request body elements that are required.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/code/schema

    Default URL: /api/sn_devops/devops/code/schema

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 1. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 2. Query parameters
    Name Description
    resource Required. Type of resource schema to return.

    Valid values (not case-sensitive):

    • branch
    • commit
    • repository

    Data type: String

    표 3. Request body parameters (XML or JSON)
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 4. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    표 5. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 6. Status codes
    Status code Description
    200 Request completed successfully.
    401 Invalid or missing authentication.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters

    Name Description
    branch Description of the branch in which the code commit was made.

    Data type: Object

    "branch": {
      "name": "String",
      "path": "String"
    }
    branch.name Name of the branch in which the code commit was made.

    Data type: String

    branch.path Relative path of the branch.

    Data type: String

    commits Description of the commits.

    Data type: Array of Objects

    "commits": [
      {
        "committedDate": "String",
        "committer": {Object},
        "details": [Array],
        "id": "String",
        "url": "String"      
      }
    ]
    commits.committedDate Date/time on which the code was committed in source DevOps tool.

    Data type: String

    Format: ISO 8601 with time zone offset

    For example: 1970-01-01T08:15:30-05:00

    commits.committer Description of the person/entity that requested the commit.

    Data type: Object

    "committer": {
      "email": "String"
    }
    commits.committer.email Email address of the person that requested the commit.

    Data type: String

    commits.details Details of the commit.
    주:
    Including details in a commit is not mandatory. This endpoint returns an empty array for details if they are not included in the commit.

    Data type: Array of Objects

    "details": [
      {
        "action": "String",
        "additions": Number,
        "changes": Number,
        "deletions": Number,
        "file": "String",
        "totalChanges": Number
      }
    ]
    commits.details.action Action that was performed on the file.

    Data type: String

    commits.details.additions Total number of additions in the file.

    Data type: Number

    commits.details.changes Total number of changes that were made.

    Data type: Number

    commits.details.deletions Total number of deletions in the file.

    Data type: Number

    commits.details.file Path of the file that was modified relative to the branch.

    Data type: String

    commits.details.totalChanges Total number of additions and deletions.

    Data type: Number

    commits.id Source platform identifier or the commit SHA.

    Data type: String

    commits.url URL of the commit, such as "https://github.com/mycompany/mobileplatform/commit/3fa85f6457174562b3fc2c963f66afa6".

    Data type: String

    name Name of the branch or repository, such as "Master" or "Platform-Mobile".

    Data type: String

    path Relative path of the branch.

    Data type: String

    repository Description of the repository in which the commit was made.

    Data type: Object

    "repository": {
      "name": "String",
      "url": "String"
    }
    repository.name Name of the repository.

    Data type: String

    repository.url URL of the repository in the source DevOps tool.

    Data type: String

    url URL of the repository, such as "https://github.com/mycompany/mobileplatform".

    Data type: String

    Sample cURL request for resource=branch

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/code/schema?resource=branch" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    
    {
       "result": {
          "name": "Master",
          "path": "refs/heads/master",
          "repository": {
             "name": "Platform-Mobile",
             "url": "https://github.com/mycompany/mobileplatform"
          }
       }
    }

    Sample cURL request for resource=commit

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/code/schema?resource=commit" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    
    {
       "result": {
          "repository": {
             "name": "Platform-Mobile",
             "url": "https://github.com/mycompany/mobileplatform"
          },
          "branch": {
             "name": "refs/heads/master"
          },
          "commits": [
             {
                "committer": {
                   "email": "name@email.com"
                },
                "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
                "url": "https://github.com/mycompany/mobileplatform/commit/3fa85f6457174562b3fc2c963f66afa6",
                "committedDate": "2022-01-01T08:15:30-05:00",
                "details": [
                   {
                      "action": "edit",
                      "changes": "",
                      "file": "/azure-pipelines.yml",
                      "additions": 1,
                      "deletions": 0,
                      "totalChanges": 1
                   }
                ]
             }
          ]
       }
    }

    Sample cURL request for resource=repository

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/code/schema?resource=repository" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    
    {
        "result": {
            "name": "Platform-Mobile",
            "url": "https://github.com/mycompany/mobileplatform"
        }
    }

    DevOps - GET /devops/onboarding/status

    Returns the current status of the specified onboarding event which is processed or being processed asynchronously by the DevOps service.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/onboarding/status

    Default URL: /api/sn_devops/devops/onboarding/status

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 7. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 8. Query parameters
    Name Description
    id Unique identifier of the onboarding event whose status to return. This value is provided in the return results of the endpoint that invoked the event request, such as /devops/onboarding/app or /devops/onboarding/tool.

    Data type: String

    표 9. Request body parameters
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 10. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    표 11. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 12. Status codes
    Status code Description
    200 Successful. The request was successfully processed.
    202 Pending - The onboarding request has been created and the DevOps service is processing the request.
    207 Partial Success - The onboarding request has been created and the DevOps service will process the request.
    400 Failed - The onboarding event failed.
    404 Failed - The endpoint failed to find any request matching the specified event ID.

    Response body parameters

    Name Description
    result Results of the onboarding request.
    Data type: Object
    "result": {
      "code": "String",
      "importRequestsSysIds": "[Array],
      "messageDetails": {Object],
      "onboardingRequestID": "String",
      "status": "String"
    }
    result.code HTTP status code.

    Data type: String

    result.importRequestsSysIds List of import requests that have been created as a part on the onboarding request.

    Data type: Array of Strings

    result.messageDetails Details about the onboarding event progress.
    Data type: Object
    "messageDetails": {
      "apps": [Array],
      "pipelines": [Array],
      "plans": [Array],
      "repositories": [Array],
      "status": "String",
      "toolResponse": [Array]
    }
    result.messageDetails.apps Defines the apps to create within the associated ServiceNow instance.

    Data type: Array of Objects

    "apps": [{
      "appId": "String",
      "message": "String",
      "name": "String",
      "status": "String",
    }]
    result.messageDetails.apps.appId Sys_id of the application that was generated when the application was onboarded.

    Data type: String

    Table: Apps [sn_devops_app]

    result.messageDetails.apps.message Message that describes the status of the application onboarding.

    Data type: String

    result.messageDetails.apps.name Name of the application being onboarded.

    Data type: String

    result.messageDetails.apps.status Current status of the application onboarding.
    Possible values:
    • Failed
    • Partial Success
    • Success

    Data type: String

    result.messageDetails.pipelines List of pipelines associated with the onboarding event and their corresponding details.

    Data type: Array of Objects

    "pipelines": [{
      "changeStepAssociation": [Array],
      "errors": "String",
      "message": "String",
      "name": "String",
      "status": "String",
    }]
    result.messageDetails.pipelines.changeStepAssociation Array of objects that describe any change steps that are associated with the onboarding.

    Data type: Array of Objects

    "changeStepAssociation": [{
      "changeStepName": "String",
      "status": "String",
      "summary": "String",
    }]
    result.messageDetails.pipelines.changeStepAssociation.changeStepName Name of the change step.

    Data type: String

    result.messageDetails.pipelines.changeStepAssociation.status Status of change step association to the pipeline.
    Possible values:
    • Failed
    • Success

    Data type: String

    result.messageDetails.pipelines.changeStepAssociation.summary Summary of the status of the change step association.

    Data type: String

    result.messageDetails.pipelines.errors List of errors detected when associating the pipeline.

    Data type: Array

    result.messageDetails.pipelines.message Message that describes the status of the pipeline association.

    Data type: String

    result.messageDetails.pipelines.name Name of the pipeline.

    Data type: String

    result.messageDetails.pipelines.status Status of the pipeline association.

    Data type: String

    result.messageDetails.plans List of plans associated with the onboarding event and their corresponding details.

    Data type: Array of Objects

    "plans": [{
      "errors": "String",
      "message": "String",
      "name": "String",
      "status": "String",
    }]
    result.messageDetails.plans.errors List of errors detected when associating the plan.

    Data type: Array

    result.messageDetails.plans.message Message that describes the status of the pipeline association.

    Data type: String

    result.messageDetails.plans.name Name of the plan.

    Data type: String

    result.messageDetails.plans.status Status of the plan association.

    Data type: String

    result.messageDetails.repositories List of repositories associated with the onboarding event and their corresponding details.

    Data type: Array of Objects

    "repositories": [{
      "configureStatus": {Object}, 
      "name": "String",
      "status": "String",
    }]
    result.messageDetails.repositories.configureStatus Details of the webhook configuration status for the repository.

    Data type: Object

    "configureStatus": {
      "message": "String",
      "status": "String",
    }
    result.messageDetails.repositories.configureStatus.message Message that describes the current webhook configuration status.

    Data type: String

    result.messageDetails.repositories.configureStatus.status Status of the webhook configuration.

    Data type: String

    result.messageDetails.repositories.message Message that describes the current repository association status.

    Data type: String

    result.messageDetails.repositories.name Name of the repository.

    Data type: String

    result.messageDetails.repositories.status Status of the repository association.

    Data type: String

    result.messageDetails.status Status of the onboarding request.
    Possible values:
    • Failed
    • Partial Success
    • Success

    Data type: String

    result.messageDetails.toolResponse List of tools to onboard within the associated ServiceNow instance.

    Data type: Array of Objects

    "toolResponse": [{
      "configureStatus": {Object},
      "connectStatus": {Object},
      "createStatus": {Object},
      "discoveryStatus": {Object},
      "name": "String",
      "status": "String",
      "type": "String"
    }]
    result.messageDetails.toolResponse.configureStatus Configuration status of the tool. In case of success, it returns the status and message. In case of error, it returns the status and error.

    Data type: Object

    "configureStatus": {
      "error": "String",
      "message": "String",
      "status": "String"
    }
    result.messageDetails.toolResponse.configureStatus.error Errors detected during tool configuration.

    Data type: String

    result.messageDetails.toolResponse.configureStatus.message Message that describes the successful status of the tool configuration.

    Data type: String

    result.messageDetails.toolResponse.configureStatus.status Status of the tool configuration.

    Data type: String

    result.messageDetails.toolResponse.connectStatus Connection status of the tool. In case of success, it returns the status and message. In case of error, it returns the status and error.

    Data type: Object

    "connectStatus": {
      "error": "String",
      "message": "String",
      "status": "String"
    }
    result.messageDetails.toolResponse.connectStatus.error Errors detected during tool connection.

    Data type: String

    result.messageDetails.toolResponse.connectStatus.message Message that describes the successful status of the tool connection.

    Data type: String

    result.messageDetails.toolResponse.connectStatus.status Status of the tool connection.

    Data type: String

    result.messageDetails.toolResponse.createStatus Creation status of the tool. In case of success, it returns the status and message. In case of error, it returns the status and error.

    Data type: Object

    "createStatus": {
      "error": "String",
      "message": "String",
      "status": "String"
    }
    result.messageDetails.toolResponse.createStatus.error Errors detected during tool creation.

    Data type: String

    result.messageDetails.toolResponse.createStatus.message Message that describes the successful status of the tool creation.

    Data type: String

    result.messageDetails.toolResponse.createStatus.status Status of the tool creation.

    Data type: String

    result.messageDetails.toolResponse.discoveryStatus Discovery status of the tool. In case of success, it returns the status and message. In case of error, it returns the status and error.

    Data type: Object

    "discoveryStatus": {
      "error": "String",
      "imports: [Array],
      "message": "String",
      "status": "String"
    }
    result.messageDetails.toolResponse.discoveryStatus.error Errors detected during tool discovery.

    Data type: String

    result.messageDetails.toolResponse.discoveryStatus.imports List of entities that were discovered.

    Data type: Array of Objects

    "imports": [{
      "details": "String",
      "id": "String",
      "status": "String"
    }]
    result.messageDetails.toolResponse.discoveryStatus.imports.details Details that describe the import performed.

    Data type: String

    result.messageDetails.toolResponse.discoveryStatus.imports.id Sys_id of the import request.

    Data type: String

    Table: sn_devops_m2m_inbound_event_import_request

    result.messageDetails.toolResponse.discoveryStatus.imports.status Status of the import.

    Data type: String

    result.messageDetails.toolResponse.discoveryStatus.message Message that describes the status of the tool discovery.

    Data type: String

    result.messageDetails.toolResponse.discoveryStatus.status Status of the tool discovery.

    Data type: String

    result.messageDetails.toolResponse.name Name of the tool being onboarded.

    Data type: String

    result.messageDetails.toolResponse.status Status of the tool onboarding.

    Data type: String

    result.messageDetails.toolResponse.type Type of tool, such as Jira or Jenkins.

    Data type: String

    result.onboardingRequestID Unique identifier of the onboarding request. Use this value when calling the /devops/onboarding/status endpoint to obtain the status of the associated tool onboarding process.

    Data type: String

    result.status Status of the onboarding request.
    Possible values:
    • Failed
    • Partial Success
    • Success

    Data type: String

    cURL request

    The following example shows the status request of a tool onboarding.

    curl -X GET "https://servicenow-instance/api/sn_devops/v1/devops/onboarding/status?id=IBE0001603" \
    -H "Accept: application/json" \
    -H "Content-Type: application/json" \
    -u "username":"password" \

    {
        "result": {
            "code": "207",
            "onboardingRequestID": "IBE0001603",
            "status": "partial-success",
            "messageDetails": {
                "status": "Partial Success",
                "toolResponse": [
                    {
                        "name": "Primary Azure",
                        "type": "Azure DevOps",
                        "status": "Partial Success",
                        "createStatus": {
                            "status": "Success",
                            "message": "Created successfully"
                        },
                        "connectStatus": {
                            "status": "Failed",
                            "error": "Method failed: (/testFirst/_apis/work/boards) with code: 401 - Invalid username/password combo"
                        }
                    },
                    {
                        "name": "Primary Jenkins",
                        "type": "Jenkins",
                        "status": "Success",
                        "createStatus": {
                            "status": "Success",
                            "message": "Created successfully"
                        },
                        "connectStatus": {
                            "status": "Success",
                            "message": "Connected successfully"
                        },
                        "discoveryStatus": {
                            "status": "Success",
                            "message": "Discovered successfully",
                            "imports": [
                                {
                                    "status": "completed",
                                    "id": "2a4d216bdb2d2450fe4fd6a75e9619c3",
                                    "details": "Discovered 1 new job(s) and 3 new pipeline(s)\n"
                                }
                            ]
                        }
                    },
                    {
                        "name": "Primary GitHub",
                        "type": "GitHub",
                        "status": "Success",
                        "createStatus": {
                            "status": "Success",
                            "message": "Created successfully"
                        },
                        "connectStatus": {
                            "status": "Success",
                            "message": "Connected successfully"
                        },
                        "discoveryStatus": {
                            "status": "Success",
                            "message": "Discovered successfully",
                            "imports": [
                                {
                                    "status": "completed",
                                    "id": "7f4d616bdb2d2450fe4fd6a75e9619c2",
                                    "details": "Discovered 5 new repositories. "
                                }
                            ]
                        }
                    },
                    {
                        "name": "Primary Bitbucket",
                        "type": "BitBucket",
                        "status": "Success",
                        "createStatus": {
                            "status": "Success",
                            "message": "Created successfully"
                        },
                        "connectStatus": {
                            "status": "Success",
                            "message": "Connected successfully"
                        },
                        "discoveryStatus": {
                            "status": "Success",
                            "message": "Discovered successfully",
                            "imports": [
                                {
                                    "status": "completed",
                                    "id": "815da16bdb2d2450fe4fd6a75e9619d0",
                                    "details": "Discovered 11 new repositories. "
                                }
                            ]
                        }
                    },
                    {
                        "name": "Primary Gitlab",
                        "type": "GitLab",
                        "status": "Partial Success",
                        "createStatus": {
                            "status": "Success",
                            "message": "Created successfully"
                        },
                        "connectStatus": {
                            "status": "Failed",
                            "error": "The current operation ended in state: ERROR"
                        }
                    }
                ],
                "importRequestsSysIds": [
                    "2a4d216bdb2d2450fe4fd6a75e9619c3",
                    "7f4d616bdb2d2450fe4fd6a75e9619c2",
                    "815da16bdb2d2450fe4fd6a75e9619d0"
                ]
            }
        }
    }

    cURL request

    The following example shows the status request of an application onboarding.

    curl -X POST "https://servicenow-instance/api/sn_devops/v1/devops/onboarding/status?onboardingRequestID=IBE0001604" \
    -H "Accept: application/json" \
    -H "Content-Type: application/json" \
    -u "username":"password" \

    {
        "result": {
            "code": "207",
            "onboardingRequestID": "IBE0001604",
            "status": "partial-success",
            "messageDetails": {
                "status": "Partial Success",
                "apps": [
                    {
                        "name": "Bike Rentals Service",
                        "status": "Success",
                        "appId": "c7fd696bdb2d2450fe4fd6a75e961993",
                        "message": "App by name 'Bike Rentals Service' has been successfully created"
                    }
                ],
                "pipelines": [
                    {
                        "name": "Bike Rentals",
                        "status": "Success",
                        "message": "Successfully associated with app 'Bike Rentals Service'",
                        "changeStepAssociation": [
                            {
                                "status": "Success",
                                "changeStepName": "Prod",
                                "summary": "Change step with name 'Prod' has been created"
                            }
                        ]
                    }
                ],
                "repositories": [
                    {
                        "name": "nowdevops01/BikeRentals",
                        "status": "Partial Success",
                        "message": "Successfully associated with app 'Bike Rentals Service'",
                        "configureStatus": {
                            "status": "Failed",
                            "message": "Webhook configuration failed due to empty credentials for repository by name nowdevops01/BikeRentals in tool Primary GitHub"
                        }
                    }
                ],
                "plans": [
                    {
                        "status": "Failed",
                        "name": "testFirst",
                        "errors": [
                            "Plan by name 'testFirst' does not exist in tool Primary Azure"
                        ]
                    }
                ]
            }
        }
    }

    DevOps - GET /devops/orchestration/changeControl

    Checks if the orchestration task is under change control.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/orchestration/changeControl

    Default URL: /api/sn_devops/devops/orchestration/changeControl

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 13. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 14. Query parameters
    Name Description
    orchestrationTaskName Name of the orchestration task to check.

    Data type: String

    testConnection Flag that indicates whether to test the end-to-end connection between the instance and the DevOps tool.
    Valid values:
    • true: Test the end-to-end connection.
    • false: Do'ot test the end-to-end connection.

    Data type: Boolean

    Default: false

    toolId Required. Sys_id of the orchestration tool.

    Data type: String

    Table: Orchestration Tool [sn_devops_orchestration_tool]

    toolType Type of tool.

    Valid values: jenkins

    Data type: String

    표 15. Request body parameters
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 16. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    Authorization
    Starting with v2, this API supports token-based authentication. Tokens can be acquired by clicking the Copy token button on the tool record, located in the Tool [sn_devops_tool] table. The token can then be used in an authorization header in the format Authorization: sn_devops.DevOpsToken <tool_sys_id>:<tool_token>.
    주:
    If Basic Auth details (user name and password) are provided in addition to an authorization header with token, Basic Auth takes precedence.

    If the devops.system user is not available in your instance, use the Switch to this user after token based authentication is successful property. This property enables setting any user that has the sn_devops.integration role, which is needed to complete the token authentication. For information, see DevOps Change Velocity properties.

    표 17. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 18. Status codes
    Status code Description
    200 Successful. The request was successfully processed.
    401 Invalid or missing authentication.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters (JSON or XML)

    Name Description
    changeControl Flag that indicates whether the orchestration task is under change control.
    Possible values:
    • true: Under change control.
    • false: Not under change control.

    Data type: Boolean

    Under change control and using API v2

    curl -X GET "https://instance.servicenow.com/api/sn_devops/v2/devops/orchestration/changeControl?toolId=1c219f7e8708f1508ca933383cbb3543&orchestrationTaskName=Platform-Analytics-UAT-Deployment&orchestrationTaskURL=https%253A%252F%252Fjenkins.mycompany.com%253A8080%252Fjob%252FMobile-Platform-deploy%252F&toolType=jenkins" 
    -H "accept: application/json"\
    -H "Authorization: sn_devops.DevOpsToken 1c219f7e8708f1508ca933383cbb3543:FtN13dfDuahYEtdfDvhHorh0QPp9na3u"

    Response body.

    {
    "result": {
      "changeControl": true,
      "status": "Success" 
      } 
    }

    Not under change control and using API v1

    curl -X GET "https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/changeControl?toolId=f0ca45679323008b52f3b457415ae6&orchestrationTaskName=Platform-Analytics-UAT-Deployment&orchestrationTaskURL=https%253A%252F%252Fjenkins.mycompany.com%253A8080%252Fjob%252FMobile-Platform-deploy%252F&toolType=jenkins" 
    -H "accept: application/json"\
    -u "username":"password"

    Response body.

    {
        "result": {
            "changeControl": false
        }
    }

    DevOps - GET /devops/orchestration/changeInfo

    Retrieves change request details for a specified orchestration pipeline execution.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/orchestration/changeInfo

    Default URL: /api/sn_devops/devops/orchestration/changeInfo

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 19. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 20. Query parameters
    Name Description
    branchName Name of the branch associated with the orchestration task.
    주:
    You should provide this parameter when referencing multi-branch pipelines or the response may include incorrect change details.

    Data type: String

    buildNumber Required. Pipeline build number within the orchestration tool.

    Data type: String

    pipelineName Optional for Jenkins Freestyle or Maven projects, required for all others. Orchestration pipeline name.

    Data type: String

    projectName Required for Jenkins Freestyle or Maven projects, optional for all others. Orchestration tool project name.

    Data type: String

    stageName Optional for Jenkins Freestyle or Maven projects, required for all others. Orchestration stage name.

    Data type: String

    Maximum length: 160

    toolId Required. Sys_id of the orchestration tool.

    Data type: String

    Table: Orchestration Tool [sn_devops_orchestration_tool]

    표 21. Request body parameters (XML or JSON)
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 22. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    Authorization
    Starting with v2, this API supports token-based authentication. Tokens can be acquired by clicking the Copy token button on the tool record, located in the Tool [sn_devops_tool] table. The token can then be used in an authorization header in the format Authorization: sn_devops.DevOpsToken <tool_sys_id>:<tool_token>.
    주:
    If Basic Auth details (user name and password) are provided in addition to an authorization header with token, Basic Auth takes precedence.

    If the devops.system user is not available in your instance, use the Switch to this user after token based authentication is successful property. This property enables setting any user that has the sn_devops.integration role, which is needed to complete the token authentication. For information, see DevOps Change Velocity properties.

    표 23. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 24. Status codes
    Status code Description
    200 Successful. The request was successfully processed.
    400 Bad Request. A bad request type or malformed request was detected.
    404 Not found. The requested item wasn't found.

    Response body parameters (JSON or XML)

    Name Description
    changeFound Flag that indicates whether the change request was located.
    Possible values:
    • true: Change request was found.
    • false: Change request wasn't found.

    Data type: Boolean

    number Change request number.

    Data type: String

    phase Current phase.

    Data type: String

    phase_state State of the current phase.

    Data type: String

    priority Priority of the change request. Priority is based on the impact and urgency of the request. It identifies how quickly the service desk should address the request.
    Possible values:
    • 1: Critical
    • 2: High
    • 3: Moderate
    • 4: Low

    Data type: String

    risk Level of risk for the change.
    Possible values:
    • Low
    • High
    • Moderate

    Data type: String

    state State of the change request.
    Possible values:
    • Assess
    • Authorize
    • Canceled
    • Closed
    • Implement
    • New
    • Review
    • Scheduled

    Data type: String

    Default: New

    sys_id Sys_id of the change request.

    Data type: String

    type Type of change request.
    Possible values:
    • Emergency
    • Normal
    • Standard

    Data type: String

    url URL of the change request within the associated ServiceNow instance.

    Data type: String

    changeAssignmentGroup Assignment group of the change request.

    Data type: String

    changeApprovers List of approvers with whom the change is pending for approval.

    Data type: String

    plannedStartDate Planned start date and time of the change.

    Data type: String

    plannedEndDate Planned end date and time of the change.

    Data type: String

    cURL request

    curl -X GET "https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/changeInfo?toolId=1487f457db642810765555535e9619d3&pipelineName=Automation/apps HR/family release&stageName=deployfamilyrelease&buildNumber=1639"  
    -H "accept: application/json"\ 
    -u "username":"password"
    {  
      "result": {  
        "changeFound": true,  
        "sys_id": "ee89341bdb642810765555535e96196e",  
        "number": "CHG0030001",  
        "type": "normal",  
        "state": "0",  
        "phase": "requested",  
        "phase_state": "open",  
        "priority": "4",  
        "risk": "4",  
        "url": "https://instance.servicenow.com/change_request.do?sys_id=ee89341bdb642810765555535e96196e",  
        "changeAssignmentGroup": "Change Management", 
        "changeApprovers": "Ron Kettering, Christen Mitchell, Howard Johnson, Luke Wilson", 
        "plannedStartDate": "2023-02-05 08:00:00", 
        "plannedEndDate": "2024-02-05 08:00:00" 
      }  
    }

    DevOps - GET /devops/orchestration/schema

    Returns the schema object for a specified orchestration resource.

    Once you have the required schema object, use it to create the request body for your corresponding POST call; /orchestration/orchestrationTask or /orchestration/taskExecution.

    주:
    This endpoint only returns the request body elements that are required.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/orchestration/schema

    Default URL: /api/sn_devops/devops/orchestration/schema

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 25. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 26. Query parameters
    Name Description
    resource Type of resource schema to return.
    Valid values (not case-sensitive):
    • build_details
    • callback
    • orchestration_task
    • task_execution

    Data type: String

    표 27. Request body parameters
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 28. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    표 29. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 30. Status codes
    Status code Description
    200 Request completed successfully.
    401 Invalid or missing authentication.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters

    Name Description
    callbackURL URL of the callback.

    Data type: String

    endDateTime Date/time that the task execution ended.

    Data type: String

    name Name of the orchestration task.

    Data type: String

    number Task execution number. Same as an incident number.

    Data type: String

    orchestrationTaskDetails Description of the orchestration task.

    Data type: Object

    "orchestrationTaskDetails": {
      "message": "String",
      "name": "String",
      "triggerType": "String",
      "url": "String"
    }
    orchestrationTaskDetails.message Free-form text message.

    Data type: String

    orchestrationTaskDetails.name Name of the orchestration task.

    Data type: String

    orchestrationTaskDetails.triggerType The way the orchestration task was started.

    Data type: String

    orchestrationTaskDetails.url URL of the associated orchestration tool's orchestration task.

    Data type: String

    orchestrationTaskURL URL of the orchestration task.

    Data type: String

    result Execution result of the task execution.
    Valid values:
    • Failed
    • Success

    Data type: String

    startDateTime Date/time that the task execution started.

    Data type: String

    taskExecutionURL URL of the task to execute.

    Data type: String

    triggerType The way the orchestration task was started.

    Valid values:

    • scm: Git/scm tool code commit triggered the job.
    • upstream: Upstream job triggered this job.
    • user: User manually started the job.

    Data type: String

    url URL of the associated orchestration tool's orchestration task.

    Data type: String

    Sample cURL request with resource=task_execution

    curl -X GET \
    'https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/schema?resource=task_execution' \
    -H 'Accept: application/json'\
    -u 'username':'password'
    {
    "result": {
      "number": 40,
      "url": "https://jenkins.mycompany.com:8080/job/Mobile-Platform-CI/40/",
      "startDateTime": "1970-01-01T08:15:30-05:00",
      "endDateTime": "1970-01-01T08:25:30-05:00",
      "triggerType": "upstream",
      "result": "Success",
      "orchestrationTaskDetails": {
        "name": "Mobile-Platform-CI",
        "url": "https://jenkins.mycompany.com:8080/job/Mobile-Platform-CI/"
        }
      }
    }

    Sample cURL request with resource=orchestration_task

    curl -X GET \ 
    'https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/schema?resource=orchestration_task' \
    -H 'Accept: application/json'\
    -u 'username':'password' 
    
    { 
    "result": { 
      "name": "Mobile-Platform-CI", 
      "url": "https://jenkins.mycompnay.com:8080/job/Mobile-Platform-CI/" 
      } 
    } 

    Sample cURL request with resource=callback

    curl -X GET \
    'https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/schema?resource=task_execution' \
    -H 'Accept: application/json' \
    -u 'username':'password'
    
    { 
      "result": { 
        "callbackURL": "http://127.0.0.1:8090/jenkins/sn-devops/9b0feb79-f0b9-4661-83ef-2861b8924784", 
        "orchestrationTaskURL": "http://127.0.0.1:8090/jenkins/job/felipe-downstream/", 
        "orchestrationTaskDetails": { 
          "message": "Started by upstream project \"felipe-upstream\" build number 27", 
          "triggerType": "upstream" 
        } 
      } 
    } 

    DevOps - GET /devops/orchestration/stepMapping

    Verifies that the information being passed is valid for the creation of an orchestration task and is valid for association to a previously created step.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/orchestration/stepMapping

    Default URL: /api/sn_devops/devops/orchestration/stepMapping

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 31. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 32. Query parameters
    Name Description
    branchName Name of the branch associated with the orchestration task.

    Data type: String

    isMultiBranch If the orchestration tool is Jenkins, flag that indicates whether the project is of type Multibranch.
    Valid values:
    • true: Project is of type Multibranch.
    • false: Project is not of type Multibranch.

    Data type: Boolean

    Default: false

    parentStageName If the orchestration task is a child nested inside a parent orchestration task, the name of the parent orchestration task.

    Data type: String

    parentStageURL If the orchestration task is a child nested inside a parent orchestration task, the URL of the parent orchestration task.

    Data type: String

    orchestrationTaskName Required. Name of the orchestration task.

    Data type: String

    orchestrationTaskURL Required. URL of the orchestration task.
    주:
    Must be percent (%) encoded, such as https%3A%2F%2Fjenkins.mycompany.com%3A8080%2Fjob%2FMobile-Platform-deploy%2F.
    Data type: String
    testConnection Flag that indicates whether to test the end-to-end connection between the instance and the DevOps tool.
    Valid values:
    • true: Test the end-to-end connection.
    • false: Do not test the end-to-end connection.

    Data type: Boolean

    Default: false

    toolId Required. Sys_id of the orchestration tool. Located in the Orchestration Tool [sn_devops_orchestration_tool] table.

    Data type: String

    toolType Required. Type of tool.

    Valid values: jenkins

    Data type: String

    표 33. Request body parameters
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 34. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    표 35. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 36. Status codes
    Status code Description
    200 Successful. The request was successfully processed.
    401 Unauthorized. The user credentials are incorrect or have not been passed.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters

    Element Description
    status Flag that indicates whether the verification was successful.
    Valid values:
    • true: Verification was successful.
    • false: Verification wasn't successful.

    Data type: Boolean

    stepValid Flag that indicates whether the information sent is valid.
    Valid values:
    • true: Information sent is valid.
    • false: Information sent isn't valid.

    Data type: Boolean

    Sample cURL request

    curl -X GET "https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/stepMapping?toolId=f0ca45679323008b52f3b457415ae6&orchestrationTaskName=Platform-Analytics-UAT-Deployment&orchestrationTaskURL=https%253A%252F%252Fjenkins.mycompany.com%253A8080%252Fjob%252FMobile-Platform-deploy%252F&toolType=jenkins "
     -H "Accept: application/json" \
     -u "username":"password"
    

    Results if information is valid.

    {
      "result": {
        "stepValid": true,
        "status": "Success"
      }
    }

    Sample cURL request

    curl -X GET "https://instance.servicenow.com/api/sn_devops/v1/devops/orchestration/stepMapping?toolId=f0ca45679323008b52f3b457415ae6&orchestrationTaskName=Platform-Analytics-UAT-Deployment&orchestrationTaskURL=https%253A%252F%252Fjenkins.mycompany.com%253A8080%252Fjob%252FMobile-Platform-deploy%252F&toolType=jenkins "
     -H "Accept: application/json" \
     -u "username":"password"
    

    Results if information is invalid.

    {
    "result": {
      "stepValid": false,
      "status": "Success"
    }
    

    DevOps - GET /devops/plan/schema

    Returns the schema object for a specific plan: app, version, or work item.

    Once you have the required schema object, use it to create the request body for your corresponding POST call; POST /plan/app, POST /plan/version, or POST /plan/workitem.

    주:
    This endpoint only returns the request body elements that are required.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/plan/schema

    Default URL: /api/sn_devops/devops/plan/schema

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 37. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 38. Query parameters
    Name Description
    resource Type of resource schema to return.

    Valid values (not case-sensitive):

    • app
    • version
    • work_item

    Data type: String

    표 39. Request body parameters
    Name Description
    None

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 40. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    표 41. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 42. Status codes
    Status code Description
    200 Successful. The request was successfully processed.
    401 Invalid or missing authentication.
    404 Not Found. The specified record couldn't be found.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters

    Name Description
    app Description of the application to associate with the version.

    Data type: Object

    "app": {
      "createdDateTime": "String",
      "id": "String",
      "shortDescription": "String",
      "team": {Object},
      "url": "String"
    }
    app.createdDateTime Date/time the application was created in the source DevOps tool.

    Data type: String

    app.id Unique identifier of the application. Generated by the source planning tool.

    Data type: String

    app.shortDescription Brief description of the associated application.

    Data type: String

    app.team Description of the team associated with the application.

    Data type: Object

    "team": {
      "id": "String",
      "name": "String"
    }
    app.team.id Unique identifier of the team associated with the application. Generated by the source planning tool.

    Data type: String

    app.team.name Name of the team associated with the application.

    Data type: String

    app.url URL of the application on the source planning tool site.

    Data type: String

    assignedTo Description of the person to which the work item is assigned.

    Data type: Object

    "assignedTo": {
      "email": "String",
      "id": "String",
      "name": "String",
      "userName": "String"
    }
    assignedTo.email Email address of the person assigned to the work item.

    Data type: String

    assignedTo.id Unique identifier of the person assigned to the work item.

    Data type: String

    assignedTo.name Name of the person assigned to the work item.

    Data type: String

    assignedTo.userName User name of the person assigned to the work item.

    Data type: String

    createDateTime Date and time that the application, version, or work item record was created.

    Data type: String

    id Unique identifier of the application, version, or work item. Generated by the source planning tool.

    Data type: String

    name Name of the application.

    Data type: String

    path Relative path to the application.

    Data type: String

    shortDescription Brief description of the application, version, or work item.

    Data type: String

    state State of the work item. Generated by the source planning tool.

    Data type: String

    team Description of the team associated with the application.

    Data type: Object

    "team": {
      "id": "String",
      "name": "String"
    }
    team.id Unique identifier of the team associated with the application. Generated by the source planning tool.

    Data type: String

    team.name Name of the team associated with the application.

    Data type: String

    type Type of work item. Generated by the planning tool.

    Data type: String

    url URL to use to access the application, version, or work item.

    Data type: String

    version Array that describes the version.

    Data type: Object

    "version": {
      "app": {Object},
      "createdDateTime": "String",
      "id": "String",
      "shortDescription": "String",
      "url": "String"
    }
    version.app Description of the application to associate with the version.

    Data type: Object

    "app": {
      "createdDateTime": "String",
      "id": "String",
      "shortDescription": "String",
      "team": {Object},
      "url": "String"
    }
    version.app.createdDateTime Date/time that the version was created on the source DevOps tool.

    Data type: String

    version.app.id Unique identifier of the application. Generated by the source planning tool.

    Data type: String

    version.app.shortDescription Brief description of the associated application.

    Data type: String

    version.app.team Description of the team associated with the application.

    Data type: Object

    "team": {
      "id": "String",
      "name": "String"
    }
    version.app.team.id Unique identifier of the team associated with the application. Generated by the source planning tool.

    Data type: String

    version.app.team.name Name of the team associated with the application.

    Data type: String

    version.app.url URL of the application on the source planning tool site.

    Data type: String

    version.createdDateTime Date/time that the version was created on the source DevOps tool.

    Data type: String

    version.id Unique identifier of the version. Generated by the source planning tool.

    Data type: String

    version.shortDescription Brief description of the associated version.

    Data type: String

    version.url URL of the version on the source planning tool site.

    Data type: String

    Sample cURL request for resource=app

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/plan/schema?resource=app" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    {
      "result": {
        "id": "PRODUCT1234",
        "shortDescription": "Mobile UI",
        "createdDateTime": "1970-01-01T08:15:30-05:00",
        "team": {
          "name": "Mobile UI",
          "id": "f0ca45679323008b52f3b457415ae6"
        },
        "url": "https://jira.com/mycompany/browse/PRODUCT-125"
      }
    }

    Sample cURL request for resource=version

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/plan/schema?resource=version" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    
    {
      "result": {
        "id": "REL1234",
        "shortDescription": "APIs Release",
        "createdDateTime": "1970-01-01T08:15:30-05:00",
        "app": {
          "id": "PRODUCT1234",
          "shortDescription": "Mobile UI",
          "createdDateTime": "1970-01-01T08:15:30-05:00",
          "team": {
            "name": "Mobile UI",
            "id": "f0ca45679323008b52f3b457415ae6"
          },
          "url": "https://jira.com/mycompany/browse/PRODUCT-125"
        },
        "url": "https://jira.com/mycompany/browse/REL-125"
      }
    }

    Sample cURL request for resource=work_item

    curl "https://instance.servicenow.com/api/sn_devops/v1/devops/plan/schema?resource=work_item" \
    --request GET \
    --header "Accept:application/json" \
    --user "username":"password"
    
    {
      "result": {
        "id": "STR1234",
        "type": "Story",
        "shortDescription": "Planning API Spec",
        "state": "In-progress",
        "createdDateTime": "1970-01-01T08:15:30-05:00",
        "assignedTo": {
          "name": "Leo Neo",
          "userName": "lenn",
          "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
          "email": "lenn@smithworksinc.com"
        },
        "version": {
          "id": "REL1234",
          "shortDescription": "APIs Release",
          "createdDateTime": "1970-01-01T08:15:30-05:00",
          "app": {
            "id": "PRODUCT1234",
            "shortDescription": "Mobile UI",
            "createdDateTime": "1970-01-01T08:15:30-05:00",
            "team": {
              "name": "Mobile UI",
              "id": "f0ca45679323008b52f3b457415ae6"
            },
            "url": "https://jira.com/mycompany/browse/PRODUCT-125"
            },
            "url": "https://jira.com/mycompany/browse/REL-125"
        },
        "app": {
          "id": "PRODUCT1234",
          "shortDescription": "Mobile UI",
          "createdDateTime": "1970-01-01T08:15:30-05:00",
          "team": {
            "name": "Mobile UI",
            "id": "f0ca45679323008b52f3b457415ae6"
          },
          "url": "https://jira.com/mycompany/browse/PRODUCT-125"
        },
        "url": "https://jira.com/mycompany/browse/HALOKEY-25"
      }
    }

    DevOps - POST /devops/artifact/registration

    Enables orchestration tools to register artifacts into a ServiceNow instance.

    This endpoint creates new artifacts and artifact versions, and associates them to commits. The following describes the endpoint process flow:
    • If the toolId is passed in the request, the endpoint validates that the tool exists within the instance. It also checks if the artifact repository specified in artifacts.repositoryName exists, and if not, creates it under the associated artifact tool.
    • If the toolId is not passed in the request, a repository is created but it is not linked to any artifact tool.
    • It then checks if the artifact specified in artifacts.name already exists, and if not, creates it under the associated repository.
    • If the artifact.version is passed in the request:
      • If it does not exist, a new artifact version record is created in the associated Artifact Version [sn_devops_artifact_version] table.
      • The endpoint then looks for associated task executions based on the provided build details (pipelineName or projectName, taskExecutionNumber, branchName, and stageName) and the orchestrationToolId parameter.
      • If a task execution is found, and its post-processing is complete, the artifact version is linked to the task execution and stored in the Artifact to TaskExecution [sn_devops_m2m_artifact_execution] table. Commits linked to these task executions are also associated to the artifact version and stored in the Artifact Version to Commit [sn_devops_m2m_artifact_version_commit] table. Any commits that are linked to previous task executions that did not create an artifact, are also associated with the artifact version.
      • If a task execution is found, and its post-processing is not complete, then the request is persisted in the Artifact Staged Request [sn_devops_artifact_staging] table. The staged request contains a reference to the task execution.
      • If a task execution is not found, the request is persisted in the staging table. The staged request contains the build details.
    • If the artifact.version is not passed in, then depending on the tool configuration, the artifact version is either retrieved by calling the /devops/tool/artifact endpoint if your artifact tool supports webhooks or through a custom subflow that retrieves the artifact version from the artifact tool.

    For additional information on artifacts, see Using DevOps change acceleration for releases.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/artifact/registration

    Default URL: /api/sn_devops/devops/artifact/registration

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 43. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 44. Query parameters
    Name Description
    orchestrationToolId Required. Sys_id of the orchestration tool associated with the artifact. The endpoint uses this information to locate task execution information.

    Data type: String

    Table: Orchestration Tool [sn_devops_orchestration_tool]

    toolId Sys_id of the artifact tool associated with the artifact.

    Data type: String

    Table: Artifact Tool [sn_devops_artifact_tool]

    표 45. Request body parameters (XML or JSON)
    Name Description
    artifacts At least one entry required. Array of objects in which each object uniquely identifies an artifact version to register.

    Data type: Array of Objects

    "artifacts": [
      {
        "name": "String",
        "repositoryName": "String",
        "semanticVersion": "String",
        "version": "String"
      }
    ]
    artifacts.name Required. Artifact file name.

    Data type: String

    Maximum length: 160 characters

    artifacts.repositoryName Required. Artifact repository name.

    If the specified repository record does not exist, it is created.

    Data type: String

    Maximum length: 160 characters

    artifacts.semanticVersion Semantic version of the artifact.

    Data type: String

    Format: MAJOR.MINOR.PATCH

    Examples of possible values:
    • 2.0.0
    • 2.0.0-rc.2
    • 2.0.0-rc.1
    • 1.0.0-beta

    Maximum length: 160 characters

    Default: Null

    artifacts.version Required if toolId is not passed. Artifact version.

    Data type: String

    Format: MAJOR.MINOR

    Maximum length: 160 characters

    Default: Null

    branchName Required if it is a multi-branch project. Name of the branch in the repository where the artifact is stored.

    Data type: String

    Maximum length: 160

    Default: Null

    pipelineName Required if projectName is not passed. Pipeline name.

    Data type: String

    Maximum length: 160

    Default: Null

    projectName Required if pipelineName is not passed. Free-form project name.

    Data type: String

    Maximum length: 160

    Default: Null

    stageName Required if pipelineName is passed. Stage name.

    Data type: String

    Maximum length: 160

    Default: Null

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 46. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    Authorization
    Starting with v2, this API supports token-based authentication. Tokens can be acquired by clicking the Copy token button on the tool record, located in the Tool [sn_devops_tool] table. The token can then be used in an authorization header in the format Authorization: sn_devops.DevOpsToken <tool_sys_id>:<tool_token>.
    주:
    If Basic Auth details (user name and password) are provided in addition to an authorization header with token, Basic Auth takes precedence.

    If the devops.system user is not available in your instance, use the Switch to this user after token based authentication is successful property. This property enables setting any user that has the sn_devops.integration role, which is needed to complete the token authentication. For information, see DevOps Change Velocity properties.

    Content-Type Data format of the request body. Only supports application/json.
    표 47. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 48. Status codes
    Status code Description
    200 Success. Success with response body.
    201 Created. Success with response body.
    400 Bad Request. The request URI does not match the APIs in the system, or the operation failed for unknown reasons. Invalid headers can also cause this error.
    500 Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.

    Response body parameters

    Name Description
    response Results of the artifact registration request.

    Data type: Object

    "response": {
      "artifact": {Object},
      "artifact_register_requests": {Object},
      "artifact_repository": {Object},
      "artifact_version": {Object}
    }
    response.artifact Results for each processed artifact.

    Data type: Object

    "artifact": {
      "create": [Array],
      "found": [Array],
      "update": [Array]
    }
    response.artifact.create If the request created artifact records, the list of sys_ids of the created records.

    Data type: Array of Objects

    "create": [
      {
        "id": "String"
      }
    ]

    Table: Artifacts [sn_devops_artifact]

    response.artifact.create.id Sys_id of the artifact record created by the request.

    Data type: String

    response.artifact.found If an artifact already exists in the Artifacts table, the list of sys_ids of the existing artifact records.
    주:
    No modifications are made to existing packages.

    Data type: Array of Objects

    "found": [
      {
        "id": "String"
      }
    ]
    response.artifact.found.id Sys_id of the existing artifact record.

    Data type: String

    response.artifact.update Currently unused
    response.artifact.update.id Currently unused
    response.artifact_register_requests Results for any artifacts register requests that have not completed processing and have been stored in the Artifact Staged Request table.

    Data type: Object

    "artifact_register_requests": {
      "create": [Array],
      "found": [Array],
      "update": [Array]
    }
    response.artifact_register_requests.create If the request created artifact staging records, the list of sys_ids of the created records.

    Data type: Array of Objects

    "create": [
      {
        "id": "String"
      }
    ]
    response.artifact_register_requests.create.id Sys_id of the artifact staging record created by the request.

    Data type: String

    response.artifact_register_requests.found If artifacts already have associated artifact staging records, the list of sys_ids of the existing artifact staging records.
    주:
    No modifications are made to existing packages.

    Data type: Array of Objects

    "found": [
      {
        "id": "String"
      }
    ]
    response.artifact_register_requests.found.id Sys_id of an existing artifact staging record.

    Data type: String

    response.artifact_register_requests.update Currently unused
    response.artifact_register_requests.update.id Currently unused
    response.artifact_repository Results for any artifact repository records that were manipulated during the processing of the request.

    Data type: Object

    "artifact_repository": {
      "create": [Array],
      "found": [Array],
      "update": [Array]
    }
    response.artifact_repository.create If artifact repositories were created by the request, the list of sys_ids of the created records.

    Data type: Array of Objects

    "create": [
      {
        "id": "String"
      }
    ]
    response.artifact_repository.create.id Sys_id of the artifact repository record created by the request.

    Data type: String

    response.artifact_repository.found If artifact repository records used in the register request already exist, the list of sys_ids of the existing records.
    주:
    No modifications are made to existing packages.

    Data type: Array of Objects

    "found": [
      {
        "id": "String"
      }
    ]
    response.artifact_repository.found.id Sys_id of an existing artifact repository record used by the request.

    Data type: String

    response.artifact_repository.update If the endpoint updates the track flag on a repository to true (from false), the list of sys_ids of the repository records that were modified.

    Data type: Array of Objects

    "update": [
      {
        "id": "String"
      }
    ]
    response.artifact_repository.update.id Sys_id of the repository record whose track flag was modified.

    Data type: String

    response.artifact_version Results for any artifact version records that were manipulated during the processing of the request.

    Data type: Object

    "artifact_version": {
      "create": [Array],
      "found": [Array],
      "update": [Array]
    }
    response.artifact_version.create Results for any artifact version records that were created during the processing of the request.

    Data type: Array of Objects

    "create": [
      {
        "id": "String"
      }
    ]
    response.artifact_version.create.id Sys_id of the artifact version record created by the request.

    Data type: String

    response.artifact_version.found If artifact version records used in the register request already exist, the list of sys_ids of the existing records.

    Data type: Array of Objects

    "found": [
      {
        "id": "String"
      }
    ]
    response.artifact_version.found.id Sys_id of the existing artifact version record used by the request.

    Data type: String

    response.artifact_version.update Currently unused
    response.artifact_version.update.id Currently unused
    status Status of the registration request.
    Possible values:
    • Success: Response body contains return results.
    • Error: Response body contains list of all errors.

    Data type: String

    Sample cURL request

    curl -X POST \
    'https://instance.servicenow.com/api/sn_devops/devops/artifact/registration?toolId=391b4ff6dba24010bc8cdd384b96198f&orchestrationToolId=99d70b36dba24010bc8cdd384b961985' \
    -H 'Accept: application/json' \
    -H 'Content-Type: application/json' \
    -u 'username':'password' \
    -d ' {"artifacts": [\
     {\
     "name": "sa-web.jar",\
     "version": "3.1",\
     "semanticVersion": "3.1.0",\
     "repositoryName": "services-1031"\
     },\
     {\
     "name": "sa-frontend.jar",\
     "version": "3.2",\
     "semanticVersion": "3.2.0",\
     "repositoryName": "services-1031"\
     }\
     ],\
     "pipelineName": "spring-boot-app",\
     "taskExecutionNumber": "160",\
     "stageName": "Build",\
     "branchName": "primary"\
    }]'
    {
    "result": {
      "status": "Success",
      "response": {
        "artifact_repository": {
          "create": [
            {
              "id": "2e50ba8bdbaa4010bc8cdd384b961988"
            }
          ],
          "update": [],
          "found": [
            {
              "id": "2e50ba8bdbaa4010bc8cdd384b961988"
            }
          ]
        },
        "artifact": {
          "create": [
            {
              "id": "6a50f603dbea4010bc8cdd384b96193d"
            },
            {
              "id": "2e50f603dbea4010bc8cdd384b96193f"
            }
          ],
          "update": [],
          "found": []
        },
        "artifact_version": {
          "create": [
            {
              "id": "a650f603dbea4010bc8cdd384b96193e"
            },
            {
              "id": "6250f603dbea4010bc8cdd384b961940"
            }
          ],
          "update": [],
          "found": []
        },
        "artifact_register_requests": {
          "create": [
            {
              "id": "6250f603dbea4010bc8cdd384b96193f"
            },
            {
              "id": "6650f603dbea4010bc8cdd384b961940"
            }
          ],
          "update": [],
          "found": []
        }
      }
     }
    }

    DevOps - POST /devops/onboarding/app

    Creates an onboarding app event that is asynchronously processed by the DevOps service.

    This endpoint can perform the following actions:
    • Create applications.
    • Associate DevOps objects such as, plan, repository, and pipeline, to an application.
    • Create a change step record and associate a change approval process to a pipeline.

    All of these actions are tool and capability specific. The following table outlines the actions available for each supported tool.

    Application onboarding matrix

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/onboarding/app

    Default URL: /api/sn_devops/devops/onboarding/app

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 49. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 50. Query parameters
    Name Description
    None
    표 51. Request body parameters
    Name Description
    apps Array of objects that define the apps to create within the associated ServiceNow instance.

    Data type: Array

    "apps": [{
      "bussinessApp": "String",
      "name": "String"
    }]
    apps.bussinessApp Name of the cmdb_ci_business_app to which map the application. This ties the DevOps application to the specified CMDB application.

    Data type: String

    apps.name Required. User friendly name of the application to create to create. An app is a DevOps product container object that ties plans, repositories, and pipelines together.

    Data type: String

    credentials Required. Credentials to use for the webhook creation. The created webhook is used by the tool to send notifications.

    Data type: Object

    "credentials": {
      "name": "String",
      "password": "String"
    }
    credentials.name Required. ServiceNow user ID of the user making the endpoint request. This user must have the devops.integration.user role. Starting with version 1.34.1, this user must have the sn_devops.admin role.

    Data type: String

    Table: User [sys_user]

    credentials.password Required. Password of the user specified in the credenitals.name parameter.

    Data type: String

    pipelines List of pipelines to associate with applications.

    Data type: Array of Objects

    "pipelines": [{
      "app": "String",
      "name": "String",
      "tool": "String"
    }]
    pipelines.app Required if a pipelines object is specified. Name of the application to associate with the plan specified in the pipelines.name parameter. The application must have already been created or be specified in the apps object of this request.

    Data type: String

    pipelines.changeSteps Change steps to create for the pipeline specified in the pipelines.name field.

    Data type: Array of Objects

    "changeSteps": [{
      "changeApprovalGroup": "String",
      "changeControlledBranches": "String",
      "changeType": "String",
      "name": "String",
      "type": "String"
    }]
    pipelines.changeSteps.changeApprovalGroup Required if a changeSteps object is specified. Name of the change approval group to associate with the pipeline. This group must already exist on the ServiceNow instance.

    Data type: String

    Table: Group [sys_user_group]

    pipelines.changeSteps.changeControlledBranches Comma-separated list of code branches that are under change control. This only applies for multi branch support.

    Data type: String

    Default: * (all branches)

    pipelines.changeSteps.changeType Required if a changeSteps object is specified. Type of change request to create.

    Data type: String

    Table: In the Type field of the Change Request [change_request] table.

    pipelines.changeSteps.name Required if a changeSteps object is specified. Name of the step to create. The step name must match the name of the corresponding step in the orchestration tool’s pipeline.

    Data type: String

    pipelines.changeSteps.type Required if a changeSteps object is specified. Type of step to create.

    Data type: String

    Table: In the Type field of the Steps [sn_devops_step] table.

    pipelines.name Required if a pipelines object is specified. Name of the pipeline to associate with the application specified in pipelines.app parameter. This pipeline must already be discovered on the ServiceNow instance.

    Data type: String

    pipelines.project Required if a pipelines object is specified and the pipelines.tool supports projects entity (for example, the ADO tool). Project to associate with the pipeline to create a unique pipeline/tool identifier. Parameter value must derive from a project in the Project [sn_devops_project] table.

    Data type: String

    pipelines.tool Required if a pipelines object is specified. Tool to associate with the pipeline to create a unique pipeline/tool identifier.

    Data type: String

    plans List of plans to associate with an application.

    Data type: Array of Objects

    "plans": [{
      "app": "String",
      "name": "String",
      "tool": "String"
    }]
    plans.apps Required if a plans object is specified. Names of applications to associate with the plan specified in the plans.name parameter. These applications must have already been created or be specified in the apps object of this request.

    Data type: Array of Strings

    plans.name Required if a plans object is specified. Name of the plan to associate with the application specified in plans.app parameter. This plan must already be discovered on the ServiceNow instance.

    Data type: String

    plans.project Required if a plans object is specified and the plans.tool supports projects entity (for example, the ADO tool). Tool to associate with the pipeline to create a unique plans/tool identifier. Parameter value must derive from a project in the Project [sn_devops_project] table.

    Data type: String

    plans.tool Required if a plans object is specified. Tool to associate with the plan to create a unique plan/tool identifier.

    Data type: String

    repositories List of repositories associated with an application. If the repositories object contains an app parameter, then it maps the repository to the application.

    Data type: Array of Objects

    "repositories": [{
      "app": "String",
      "name": "String",
      "tool": "String"
    }]
    repositories.app Required if a repositories object is specified. Name of the application to associate with this repository. The application must have already been created or be specified in the apps object of this request.

    Data type: String

    repositories.name Required if a repositories object is specified. Name of the repository to associate with the application specified in repositories.app parameter. This repository must already be discovered on the ServiceNow instance.

    Data type: String

    repositories.project Required if a repositories object is specified and the repositories.tool supports a projects entity (for example, the ADO tool). Tool to associate with the repositories to create a unique repository/tool identifier. Parameter value must derive from a project in the Project [sn_devops_project] table.

    Data type: String

    repositories.tool Required if a repositories object is specified. User friendly tool name to associate with the repository to create a unique repository/tool identifier. The tool must already be created on the ServiceNow instance.

    Data type: String

    artifactRepositories.app Required if the artifactRepositories object is specified. Name of the application to associate with this artifactRepositories. The application must have already been created or be specified in the apps object of this request.

    Data type: String

    artifactRepositories.name Required if the artifactRepositories object is specified. Name of the artifactRepositories to associate with the application specified in artifactRepositories.app parameter. This artifactRepositories must already be discovered on the ServiceNow instance.

    Data type: String

    artifactRepositories.tool Required if the artifactRepositories object is specified. User friendly tool name to associate with the artifactRepositories to create a unique artifactRepositories /tool identifier. The tool must already be created on the ServiceNow instance.

    Data type: String

    artifactRepositories.project Required if the artifactRepositories object is specified and the repositories.tool supports projects entity (for example, the ADO tool). Tool to associate with the artifactRepositories to create a unique pipeline/tool identifier.

    Data type: String

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 52. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    Content-Type Data format of the request body. Only supports application/json.
    표 53. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 54. Status codes
    Status code Description
    202 Onboarding request was successfully created.

    Response body parameters

    Name Description
    result Results of the onboarding request.
    Data type: Object
    "result": {
      "code": "String",
      "details": "String",
      "errors": {Object],
      "onboardingRequestID": "String",
      "status": "String"
    }
    result.code HTTP status code.

    Data type: String

    result.details Details about the onboarding request.

    Data type: String

    result.errors Description of any error that occurred.

    Data type: Object

    result.error.message Error message.

    Data type: String

    result.onboardingRequestID Unique identifier of the onboarding request. Use this value when calling the /devops/onboarding/status endpoint to obtain the status of the associated onboarding process.

    Data type: String

    result.status Status of the onboarding request, either Success or Failed.

    Data type: String

    cURL request

    This example creates the application Bike Rental Service and associates it with the Jenkins pipeline Bike Rentals, the GitHub repository nowDevops01/CorpSite, and the Azure plan testPlan_Bike_Rental.

    curl -X POST "https://servicenow-instance/api/sn_devops/v1/devops/onboarding/app" \ 
    -H "Accept: application/json" \ 
    -H "Content-Type: application/json" \ 
    -u "username":"password" \ 
    -d "{ 
      "apps": [ 
        { 
          "name": "Bike Rental Service" 
        } 
      ] 
      "pipelines": [ 
        { 
          "tool": "Primary Jenkins", 
          "name": "Bike Rentals", 
          "app": "Bike Rental Service", 
          "changeSteps": [ 
            { 
              "name": "Prod", 
              "type": "deploy", 
              "changeApprovalGroup": "Change Management", 
              "changeType": "normal" 
            } 
          ] 
        } 
      ], 
      "repositories": [ 
        { 
          "tool": "Primary GitHub", 
          "name": "nowDevops01/CorpSite", 
          "app": "Bike Rental Service" 
        } 
      ] 
      "plans": [ 
        { 
          "tool": "Primary Azure", 
          "name": "testPlan_Bike_Rental", 
    "project": "DemoProjecttt", 
          "apps": [ 
            "Bike Rental Service" 
          ] 
        } 
      ] 
    "artifactRepositories": [ 
    { 
    "tool": "AdoTool", 
    "name": "empb5-sonar", 
    "apps": [ 
    "appXXXXtz" 
    ] 
    } 
    ] 
     
      "credentials" : { 
        "name": "devops_user", 
        "password": "devops_password" 
      }  
    } 

    Output:

    { 
      "result":{ 
        "status": "Success", 
        "details": "Onboarding request has been created. Please use the /status api and the onboarding request number to get the status of the request", 
        "onboardingRequestID": "IBE0001045", 
        "code": "202" 
      } 
    } 

    DevOps - POST /devops/onboarding/tool

    Creates an onboarding tool event that is asynchronously processed by the DevOps service.

    Depending on the type of tool for which the request is posted, the endpoint performs the following actions:
    • Creates the tool within the associated ServiceNow instance
    • Connects to the tool
    • Tries to configure the tool (only if the connection is successful)
    • Discovers the tool (only if the connection is successful)
    All of these actions are tool specific and are executed based on the integration capabilities for the specified tool.

    Tool onboarding matrix

    The return results for this endpoint only indicate whether the request was posted, it does not indicate whether the associated tools were created. The actual tool creation is processed asynchronously. To obtain the status of the tool creation and all other actions, you must call the /devops/onboarding/status endpoint and pass in the onboardingRequestID parameter that is returned by this endpoint.

    Before you are able to access this endpoint, your admin must have configured the DevOps connection and credential alias (CreateDevOpsTool) to setup tools in the instance. For details, see Install DevOps Change Velocity. In addition, the calling entity must have the devops.integration.user role.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/onboarding/tool

    Default URL: /api/sn_devops/devops/onboarding/tool

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 55. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 56. Query parameters
    Name Description
    None
    표 57. Request body parameters
    Name Description
    credentials Required. Credentials to use for the webhook creation. The tool uses the created webhook to send notifications.

    Data type: Object

    "credentials": {
      "name": "String",
      "password": "String"
    }
    credentials.name Required. ServiceNow identifier of the user making the endpoint request. This user must have the devops.integration.user role. Starting with version 1.34.1, this user must have the sn_devops.admin role.

    Data type: String

    Table: User [sys_user]

    credentials.password Required. Password of the user specified in the credenitals.name parameter.

    Data type: String

    tools Required. Tools to create within the associated ServiceNow instance. You can create one or more tools in a single request.

    Data type: Array of Objects

    "tools": [{
      "name": "String",
      "password": "String",
      "type": "String",
      "useMidServer": Boolean,
      "username": "String",
      "url": "String"
    }]
    tools.name Required. User friendly name or label of the tool to create. This name is used to identify the tool in the DevOps service.

    Data type: String

    tools.password Required except for Agile tool. Password to use to access the tool. Supported authentications are basic and token; OAuth is not supported.

    Data type: String

    tools.type Required. Type of tool to create, such as GitHub or BitBucket. The specified value must be one of the Tool labels in the Tool Integrations [sn_devops_tool_integration] table.

    Data type: String

    tools.useMidServer Flag that indicates whether the tool connects through a MID Server.

    Valid values:

    • true: Connects through a MID Server.
    • false: Does not connect through a MID Server.

    Data type: Boolean

    tools.username Required except for Agile tool. User name to use to access the tool through this endpoint.

    Data type: String

    tools.url Required except for Agile tool. URL of the tool to create. The DevOps service uses this URL to integrate with the tool. If using the 'Azure DevOps' tool, tools.url can contain either the ADO Organization URL or the ADO Project URL.

    When providing an ADO Organization URL, the API discovers all projects under the specified organization and does not configure any projects. When providing an ADO Project URL, the API discovers entities related to the project like (pipelines, repositories, and plans) and also configures a project if the credentials object is present. To explicitly tell the API to skip the project configuration, configure a flag configureTool (type: boolean) to false. If configureTool is not explicitly provided in the payload or is set to true, the tool is automatically configured.

    Data type: String

    Headers

    The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.

    표 58. Request headers
    Header Description
    Accept Data format of the response body. Only supports application/json.
    Content-Type Data format of the request body. Only supports application/json.
    표 59. Response headers
    Header Description
    None

    Status codes

    The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.

    표 60. Status codes
    Status code Description
    202 Onboarding request was successfully created.

    Response body parameters

    Name Description
    result Results of the onboarding request.
    Data type: Object
    "result": {
      "code": "String",
      "details": "String",
      "errors": {Object},
      "onboardingRequestID": "String",
      "status": "String"
    }
    result.code HTTP status code.

    Data type: String

    result.details Detailed message about the onboarding request.

    Data type: String

    result.errors Description of any error that occurred.

    Data type: Object

    result.error.message Error message.

    Data type: String

    result.onboardingRequestID Unique identifier of the onboarding request. Use this value when calling the /devops/onboarding/status endpoint to obtain the status of the associated tool onboarding process.

    Data type: String

    result.status Status of the onboarding request, either Success or Failed.

    Data type: String

    cURL request

    The following example shows how to onboard GitHub.

    curl -X POST "https://servicenow-instance/api/sn_devops/v1/devops/onboarding/tool" \
    -H "Accept: application/json" \
    -H "Content-Type: application/json" \
    -u "username":"password" \
    -d {
      "tool":[{
        "name": "Primary GitHub",
        "type": "GitHub",
        "url": "https"//api.github.com",
        "username": "username",
        "password": "password",
        "useMidServer": false 
      }]
      "credentials" : {
        "name": "devops_user",
        "password": "devops_password"
      }
    }

    {
      "result":{
        "status": "Success",
        "details": "Onboarding request has been created. Please use the /status api and the onboarding request number to get the status of the request",
        "onboardingRequestID": "IBE0001041",
        "code": "202"
      }
    }

    DevOps - POST /devops/orchestration/changeControl

    Registers a callback with a ServiceNow instance for an orchestration task under change control, which can be called once a decision has been made on the change request.

    Before you call this endpoint, you must have an orchestration task created in your ServiceNow instance. You can create this task either through Discovery or by calling the DevOps - POST /devops/orchestration/stepMapping endpoint. You must also ensure that the orchestration task is associated to a previously defined pipeline step and that change control is enabled (by selecting the Change control option on the App Stage form.) For details, see Accelerating DevOps change.

    URL format

    Versioned URL: /api/sn_devops/{api_version}/devops/orchestration/changeControl

    Default URL: /api/sn_devops/devops/orchestration/changeControl

    주:
    Available versions are specified in the REST API Explorer. For scripted REST APIs there is additional version information on the Scripted REST Service form.

    Supported request parameters

    표 61. Path parameters
    Name Description
    api_version Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the latest.

    Data type: String

    표 62. Query parameters
    Name Description
    toolId Required. Sys_id of the DevOps tool for which to place the specified task under change control.

    Data type: String

    Table: Orchestration Tool [sn_devops_orchestration_tool]

    toolType Type of tool.

    Valid value: Any value that identifies the tool, such as "jenkins".

    Data type: String

    표 63. Request body parameters
    Name Description
    callbackURL Required. URL that the ServiceNow instance can call back once the associated change request approval process is complete. This callback should let the pipeline execution continue or not, based on the approval result.

    Data type: String

    changeRequestDetails Name-value pairs of the fields to set when closing a change request. This object can contain any fields in the Change Request record except the following:
    • impact
    • number
    • risk
    • risk_impact_analysis
    • sys_id

    If these fields are included in the request, the endpoint returns a 400 error and the change request is not updated. Also, if you include fields that require other mandatory fields to be set, and those fields are not sent, the request will fail during later processing of the pipeline. This failure is noted in the work notes of the change request, along with an error message for that particular change request, such as: Change request update failed with reason: <Error Message from platform>. Canceling change request and the related step execution.

    You can also pass the boolean parameter setCloseCode in this object to specify whether to set closure information on the associated Change Request record.
    • If set to true, the close_code field is set to the status of the job and the close_notes field is set to a link to the step execution in the associated Change Request record. The default value is true.
    • If set to false, the close_code and close_notes fields are not set and a link to the step execution is set in the work_notes field.

    Data type: Object

    isMultiBranch If the orchestration tool is Jenkins, flag that indicates whether the project is of type Multibranch.
    Valid values:
    • true: Project is of type Multibranch.
    • false: Project is not of type Multibranch.

    Data type: Boolean

    Default: false

    orchestrationTaskDetails Required. Description of the orchestration task.

    Data type: Object

    "orchestrationTaskDetails": {
      "message": "String",
      "triggerType": "String",
      "upstreamTaskExecutionURL": "String"
    }
    orchestrationTaskDetails.message Free-form text message.

    Data type: String

    orchestrationTaskDetails.triggerType Required. The way the orchestration task was started.

    Valid values:

    • scm: Git/scm tool code commit triggered the job.
    • upstream: Upstream job triggered this job.
    • user: User manually started the job.

    Data type: String

    orchestrationTaskDetails.upstreamTaskExecutionURL Required if triggerType is set to upstream. Upstream task execution URL.

    For example: https://jenkins.mycompany.com:8080/job/Mobile-Platform-test/40/

    Data type: String

    orchestrationTaskURL Required. URL of the orchestration task for which to create the call back.

    For example: https://jenkins.mycompany.com:8080/orchestration_task/Mobile-Platform-deploy/

    Data type: String

    parentNode If the orchestration task is a child nested inside a parent orchestration task, this value contains the parent node details.

    Data type: Object

    "parentNode": {
      "id": "String",
      "name": "String",
      "upstreamStageName": "String",
      "upstreamTaskExecutionURL": "String"
    }
    parentNode.id Unique ID for the parent node.

    In Jenkins, this value corresponds to a pipeline stage ID.

    Data type: String
    parentNode.name Name of the parent node.

    In Jenkins, this value corresponds to a pipeline stage name.

    Data type: String
    parentNode.upstreamStageName Name of the parent node’s upstream orchestration task.

    In Jenkins, this value corresponds to a pipeline stage name.

    Data type: String
    parentNode.upstreamTaskExecutionURL URL of the parent node’s upstream task execution.

    In Jenkins, this value corresponds to a pipeline stage execution URL.

[...]
